--- Healbot
-- Nebo
-- ZsZso / Noktrin
-- Barathaus

if GetLanguage():upper() == "DE" then
	dofile("Interface/Addons/Healbot/SetSkillTxtDE.lua")
else
	dofile("Interface/Addons/Healbot/SetSkillTxt.lua")
end
HBInitSkillTxt()

local Version = "3.7.8"
local Healbot_BarSize = 200
local HB_Loaded = false
local VarsSet = false
local updateTime = 0					-- How long since we last did an update
local updateIntervall = 0.5		-- How often do we update the frames
local OnLoadingScreen = true
local FocusHide = true
local MOTargeting = true
local HPAlert = 0.4
HealbotInitFlag = true
HUTgtShow = true
HBIsNotLocked = true
HBDebugMode = false
HBActive = true
HBPCI1 = 0
HBPCI2 = 0
HBBarDistance = 40

hbskcol = {
	[1] = {r=0,		g=0.3,	b=1,	a=1}, -- Mana
	[2] = {r=1,		g=0.9,	b=0,	a=0.6}, -- Rage
	[3] = {r=0,		g=1,	b=0,	a=0.6}, -- Focus
	[4] = {r=0.5,	g=0,	b=1,	a=0.6} -- Energy
}

local hbskintable = {
	["Classic"] = "interface/common/bar/statusbar.tga",
	["Glow"] = "interface/common/bar/steel.tga",
	["HFade"] = "interface/common/bar/bantobar.tga",
	["Round"] = "interface/common/bar/round.tga",
	["VFade"] = "interface/common/bar/gloss.tga",
	["Beveled"] = "interface/common/bar/smooth.tga",
}

local nUnitName = {
	[0] = "player",
	[1] = "party1",
	[2] = "party2",
	[3] = "party3",
	[4] = "party4",
	[5] = "party5",
	[6] = "target",
}

HBUnitFrameName = {
	[0] = "HUSelf",
	[1] = "HUParty1",
	[2] = "HUParty2",
	[3] = "HUParty3",
	[4] = "HUParty4",
	[5] = "HUParty5",
	[6] = "HUTgt",
}

local sUnitNumber = {
	["player"] = 0,
	["party1"] = 1,
	["party2"] = 2,
	["party3"] = 3,
	["party4"] = 4,
	["party5"] = 5,
	["target"] = 6,
}


function Healbot_OnLoad()
-- Register events
	HUSelf:RegisterEvent("PARTY_MEMBER_CHANGED");
--	HUSelf:RegisterEvent("UNIT_SPELLCAST_FAILED");
--	HUSelf:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
	HUSelf:RegisterEvent("UNIT_HEALTH");
	HUSelf:RegisterEvent("UNIT_MANA");
	HUSelf:RegisterEvent("UNIT_SKILL");
--	HUSelf:RegisterEvent("SPELLS_CHANGED");
--	HUSelf:RegisterEvent("RESET_QUESTTRACK");
--	HUSelf:RegisterEvent("RESET_QUESTBOOK");
--	HUSelf:RegisterEvent("SYSTEM_MESSAGE");
	HUSelf:RegisterEvent("VARIABLES_LOADED");
--	HUSelf:RegisterEvent("CHAT_MSG_WHISPER");
--	HUSelf:RegisterEvent("CHAT_MSG_PARTY");
--	HUSelf:RegisterEvent("CHAT_MSG_GUILD");
--	HUSelf:RegisterEvent("CHAT_MSG_ADDON");
--	HUSelf:RegisterForClicks("LeftButton");
--  HUSelf:RegisterForClicks("RightButton");
	HUSelf:RegisterEvent("PLAYER_DEAD");
	HUSelf:RegisterEvent("PLAYER_ALIVE");
	HUSelf:RegisterEvent("RESURRECT_REQUEST");
	HUSelf:RegisterEvent("LOADING_END");
	HUSelf:RegisterEvent("PLAYER_BUFF_CHANGED");
	HUSelf:RegisterEvent("UNIT_BUFF_CHANGED");
	HUSelf:RegisterEvent("EXCHANGECLASS_SUCCESS");
--	HUSelf:RegisterEvent("playerBuffFrame_OnLoad");
--	HUSelf:RegisterEvent("playerBuffFrame_OnUpdate");
	HUSelf:RegisterEvent("PLAYER_LEVEL_UP");
	HUSelf:RegisterEvent("PLAYER_TARGET_CHANGED");
	HUSelf:RegisterEvent("UNIT_TARGET_CHANGED");

-- Slash commands
	SlashCmdList["HEALBOT"] = hbot_SlashHandler;
	SLASH_HEALBOT1 = "/healbot";

	SaveVariables("Healbot_VAR"); --stored in SaveVariables.lua
end

function HBEnable()
	Healbot_VAR[UnitName("player")][UnitClass("player")]["shown"] = true
	Healbot_LoadSavVars()
	Healbot_UpdatePartyTxt(true)
end

function HBDisable()
	Healbot_VAR[UnitName("player")][UnitClass("player")]["shown"] = false
	Healbot_LoadSavVars()
end

function hbot_SlashHandler(a,msg)
	msg = string.lower(msg)
	if msg == "" or msg == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Healbot Help:",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot on - shows Healbot",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot off - hides Healbot",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot toggle - on / off",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot tr25 tr50 tr75 or tr100 -- tranparency commands",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot showfocus",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot hidefocus",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/healbot reset - moves healbot back, if you dragged it off the screen",1,1,1);
	elseif msg == "hidefocus" then
		FocusHide = true;
		DEFAULT_CHAT_FRAME:AddMessage("Attempting to hide Focus bar",1,1,1);
		Healbot_VAR["HideFocus"] = FocusHide;
	elseif msg == "showfocus" then
		FocusHide = false;
		DEFAULT_CHAT_FRAME:AddMessage("Attempting to show Focus bar",1,1,1);
		Healbot_VAR["HideFocus"] = FocusHide;
	elseif msg == "on" then
		HBEnable()
	elseif msg == "off" then
		HBDisable()
	elseif msg == "tr25" then
		DEFAULT_CHAT_FRAME:AddMessage("Healbot: Opacity set to 10%",1,0,0);
		Healbot_UpdateAlpha(0.25);
	elseif msg == "tr50" then
		DEFAULT_CHAT_FRAME:AddMessage("Healbot: Opacity set to 50%",1,0,0);
		Healbot_UpdateAlpha(0.5);
	elseif msg == "tr75" then
		DEFAULT_CHAT_FRAME:AddMessage("Healbot: Opacity set to 75%",1,0,0);
		Healbot_UpdateAlpha(0.75);
	elseif msg == "tr100" then
		DEFAULT_CHAT_FRAME:AddMessage("Healbot: Opacity set to 100%",1,0,0);
		Healbot_UpdateAlpha(1);
	elseif msg == "toggle" then
		if  HUSelf:IsVisible() then
			HBDisable()
		else
			HBEnable()
		end
	elseif msg == "bigger" then
		HBBigger();
	elseif msg == "smaller" then
		HBSmaller();
	elseif msg == "reset" then
		local x, y = 73, 300;
		Healbot_VAR[UnitName("player")]["x"], Healbot_VAR[UnitName("player")]["y"] = x, y
		Healbot_VAR[UnitName("player")]["scale"] = 1
		HUSelf:SetScale(1)
		Healbot_ResetGrp()
		HBLoadPosition()
	end
end

function HBBigger()
	local scale = HBRound(HUSelf:GetScale()+0.1, 2)
	if scale > 4 then scale = 4 end
	Healbot_VAR[UnitName("player")]["scale"] = scale
	HBLoadPosition()
end

function HBSmaller()
	local scale = HBRound(HUSelf:GetScale()-0.1, 2)
	if scale < 0.4 then scale = 0.4 end
	Healbot_VAR[UnitName("player")]["scale"] = scale
	HBLoadPosition()
end

function ech0(a,b,c,d,e,f,g,h,i)
		DEFAULT_CHAT_FRAME:AddMessage("val1: "..a,1,1,1);
	if b then
		DEFAULT_CHAT_FRAME:AddMessage("val2: "..b,1,0.9,0.9);
	end
	if c then
		DEFAULT_CHAT_FRAME:AddMessage("val3: "..c,1,0.8,0.8);
	end
	if d then
		DEFAULT_CHAT_FRAME:AddMessage("val4: "..d,1,0.7,0.7);
	end
	if e then
		DEFAULT_CHAT_FRAME:AddMessage("val5: "..e,1,0.6,0.6);
	end
	if f then
		DEFAULT_CHAT_FRAME:AddMessage("val6: "..f,1,0.5,0.5);
	end
	if g then
		DEFAULT_CHAT_FRAME:AddMessage("val7: "..g,1,0.4,0.4);
	end
	if h then
		DEFAULT_CHAT_FRAME:AddMessage("val8: "..h,1,0.3,0.3);
	end
	if (type(i)=="boolean") then
		if i then
			DEFAULT_CHAT_FRAME:AddMessage("val9: ".."true",1,0.2,0.2);
		elseif (i == false) then
			DEFAULT_CHAT_FRAME:AddMessage("val9: ".."false",1,0.2,0.2);
		end
	elseif i then
		DEFAULT_CHAT_FRAME:AddMessage("val9: "..i,1,0.2,0.2);
	end
end

function HBEcho(str)
	DEFAULT_CHAT_FRAME:AddMessage(str,1,1,1);
end

function HBRound(num, dp)
  local mult = 10^(dp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function Healbot_UpdateAlpha(val)
	if val == nil then
		val = Healbot_VAR["transparency"]
	end
	if val > 1 then
		val = 1
	elseif val < 0.2 then
		val = 1
	end
	HUSelf:SetAlpha(val);
	HUTgt:SetAlpha(val);
	Healbot_VAR["transparency"] = val
end

function HBCfgMenuToggle()
	if not TOP_check1:IsVisible() then
		TOP_check1:Show();
		TOP_check2:Show();
		TOP_check3:Show();
		TOP_check4:Show();
		TOP_cfg5:Show();
		TOP_cfg6:Show();
		TOP_cfg7:Show();
		TOP_cfg8:Show();
		TOP_cfg9:Show();
		TOP_cfg10:Show();
		TOP_btn3:SetText("<");
		PetCastDropDownMenu:Show();
		SkinSelDropDownMenu:Show();
		Color_cfg_btn:Show();
	else
		TOP_check1:Hide();
		TOP_check2:Hide();
		TOP_check3:Hide();
		TOP_check4:Hide();
		TOP_cfg5:Hide();
		TOP_cfg6:Hide();
		TOP_cfg7:Hide();
		TOP_cfg8:Hide();
		TOP_cfg9:Hide();
		TOP_cfg10:Hide();
		TOP_btn3:SetText(">");
		PetCastDropDownMenu:Hide();
		SkinSelDropDownMenu:Hide();
		Color_cfg_btn:Hide();
	end
end

function HBCfgMenuOption(arg1)
	if (string.find(arg1, "focus")) then
		if TOP_check2:IsChecked() then
			FocusHide = true;
			Healbot_VAR["HideFocus"] = FocusHide;
		else
			FocusHide = false;
			Healbot_VAR["HideFocus"] = FocusHide;
		end
	elseif (string.find(arg1, "target")) then
		if TOP_check3:IsChecked() then
			HUTgtShow = true;
			Healbot_VAR[UnitName("player")][UnitClass("player")]["ShowTarget"] = true;
		else
			HUTgtShow = false;
			Healbot_VAR[UnitName("player")][UnitClass("player")]["ShowTarget"] = false;
		end
	elseif (string.find(arg1, "lockpos")) then
		if TOP_check4:IsChecked() then
			HBIsNotLocked = false;
			Healbot_VAR["HBPosIsNotLocked"] = HBIsNotLocked;
		else
			HBIsNotLocked = true;
			Healbot_VAR["HBPosIsNotLocked"] = HBIsNotLocked;
		end
	elseif (string.find(arg1, "hpalertup")) and HPAlert < 0.99 then
		HPAlert = HPAlert + 0.01;
		Healbot_VAR[UnitName("player")][UnitClass("player")]["hpalert"] = HPAlert;
		local Per = HPAlert * 100;
		TOP_cfg10_txt:SetText("Red Alert: "..Per.."% HP");
	elseif (string.find(arg1, "hpalertdown")) and HPAlert > 0.01 then
		HPAlert = HPAlert - 0.01;
		Healbot_VAR[UnitName("player")][UnitClass("player")]["hpalert"] = HPAlert;
		local Per = HPAlert * 100;
		TOP_cfg10_txt:SetText("Red Alert: "..Per.."% HP");
	end
end

function IndexSkills()
	--isolate healing skills
	local healSkills = {};
	for tab = 2, 4 do
		for q = 1, 40 do
			if (GetSkillDetail(tab,q) ~= nil) then
				local name, unkn1, icon, unkn2, rank, Type, upgradeCost, isSkillable, isAvailable = GetSkillDetail(tab,q);
				if isAvailable then
					if name == skillZ[2] or name == skillZ[3] or name == skillZ[4] or name == skillZ[22] or name == skillZ[24] or name == skillZ[25] or name == skillZ[33] or name == skillZ[34] then
						table.insert(healSkills,name);
					end
				end
			else
				break
			end
		end
	end
	return healSkills
end

function PetCastDropDownMenu_OnLoad()
	local healSkills = IndexSkills();
	for _, t in ipairs(healSkills) do
		UIDropDownMenu_AddButton({["text"] = t, ["func"] = SetPetCastSkill})
	end
end

SelectedPetCastSkill = "";

function SetPetCastSkill(button)
	SelectedPetCastSkill = button:GetText();
	UIDropDownMenu_SetSelectedID(PetCastDropDownMenu, button:GetID());
	Healbot_VAR[UnitName("player")][UnitClass("player")]["PetHealSkill"] = button:GetID();
end

function PetCastDropDownMenu_OnClick(button) --textbox onclick
	--ech0("Not yet implemented please use the button to the right");
end

function SkinSelDropDownMenu_OnLoad()
	for name, path in pairs(hbskintable) do
		UIDropDownMenu_AddButton({["text"] = name, ["value"] = path, ["func"] = SetHealbotSkin})
	end
end

function SetHealbotSkin(button)
	local name = button:GetText();
	Healbot_VAR["Skin"] = name;
	UIDropDownMenu_SetSelectedID(SkinSelDropDownMenu, button:GetID());
	Healbot_SetSelectedSkin();
end

function Healbot_SetSelectedSkin()
	local skinPath = hbskintable[Healbot_VAR["Skin"]]
	if skinPath then
		for i = 0, 6 do
			getglobal(HBUnitFrameName[i].."_HEALTHBAR"):SetTexture(skinPath)
			getglobal(HBUnitFrameName[i].."_BGBAR"):SetTexture(skinPath)
			if i ~= 6 then -- No pet frame for Target
				getglobal(HBUnitFrameName[i].."Pet_HEALTHBAR"):SetTexture(skinPath)
				getglobal(HBUnitFrameName[i].."Pet_BGBAR"):SetTexture(skinPath)
			end
		end
	end
end

function SkinSelDropDownMenu_OnClick(button) --textbox onclick
	--ech0("Not yet implemented please use the button to the right");
end

function HBPetCast(tgt)
	if SelectedPetCastSkill and SelectedPetCastSkill~="" then
		Healbot_castSpell(tgt,SelectedPetCastSkill);
	end
end

function Healbot_OnEvent(frame, event, arg1, arg2)
	if (event == "VARIABLES_LOADED") then
		-- Do we need this event?
	end
	if (event == "LOADING_END") then
		if not HB_Loaded then
			Healbot_LoadSavVars()
			HB_Loaded = true
			HBLoadPosition();
			Healbot_UpdatePartyTxt(true);
			--Addon Manager support
			if AddonManager then
				local addon = {
					version 			= Version,
				  name          = "Healbot",
	  			description   = "Healbot is a party interface that is optimized for healing and has buttons to cast spells on each person in the party",
	  			author        = "Nebo / ZsZso / Noktrin / Barathaus / Robert",
				  icon          = "interface/AddOns/Healbot/textures/hb32.tga",
	  			category      = "Interface",
				  slashCommands = "/healbot",
				  disableScript = HBDisable,
				  enableScript = HBEnable,
				}
				AddonManager.RegisterAddonTable(addon)
			else
				DEFAULT_CHAT_FRAME:AddMessage("AddOn loaded: |cffFFFFFFHealbot v"..Version.."|r", 0.5, 0.7, 0.1);
			end
		else
			Healbot_UpdatePartyTxt(true);
		end
	end
	if(event == "EXCHANGECLASS_SUCCESS") then
		Healbot_LoadSavVars()
		Healbot_UpdatePartyTxt(true)
	end
	if(event == "PLAYER_LEVEL_UP") then
		Healbot_LoadSavVars()
		Healbot_UpdatePartyTxt()
	end
	if (event == "PARTY_MEMBER_CHANGED") then
		Healbot_UpdatePartyTxt(true);
	end
	if (event == "PLAYER_BUFF_CHANGED") then
		HBCheckSelfBuff();
	end
	if (event == "UNIT_BUFF_CHANGED") then
		HBCheckPartyBuff();
	end
	if(event == "PLAYER_DEAD") then
		HBLowHPToggle("off");
	end
	if(event == "PLAYER_ALIVE") then
		--DEFAULT_CHAT_FRAME:AddMessage("YOU LIVE");
	end
	if(event == "UNIT_HEALTH") then
		Healbot_SetHealth(arg1);
		Healbot_ShowRes();
	end
	if(event == "UNIT_MANA" or event == "UNIT_SKILL") then
		Healbot_SetMana(arg1);
	end
	if(event == "UNIT_TARGET_CHANGED") then
		if arg1 == "player" then
			HBCheckTarget();
		end
	end
end

function Healbot_HPDivColor(div)
	if div >= 0.76 then
		return "|cffffffff"
	elseif div >= 0.51 then
		return "|cffffff00"
	elseif div >= 0.26 then
		return "|cffff8800"
	elseif div > 0 then
		return "|cffff0000"
	end
--	Healbot_ShowRes();
	return "|cff000000"
end

function Healbot_HPColor(arg1)
	local div = UnitHealth(arg1) / UnitMaxHealth(arg1);
	return Healbot_HPDivColor(div)
end

function Healbot_PetHealth()

end

function Healbot_SetHealth(arg1)
	local curHP, maxHP = UnitHealth(arg1), UnitMaxHealth(arg1);
	local div = curHP / maxHP;
	if arg1 == "player" then
		HUSelf_HEALTHBAR:SetSize(math.ceil(Healbot_BarSize * div),34);
		if (HBShowLowHP == false) and div <= HPAlert then
			HBLowHPToggle("on");
		elseif HBShowLowHP and div >= HPAlert then
			HBLowHPToggle("off");
		end
		HUSelf_txt_hp:SetText(Healbot_HPDivColor(div)..string.sub(curHP,1,6).."/"..string.sub(maxHP,1,6));
	elseif arg1 == "pet" then
		HUSelfPet_HEALTHBAR:SetSize(math.ceil(50 * div),25);
		HUSelfPet_txt_hp:SetText(Healbot_HPDivColor(div)..string.sub(curHP,1,6));
	elseif sUnitNumber[arg1] then
		local unitNr = sUnitNumber[arg1]
		if div > 0.9 then
			getglobal(HBUnitFrameName[unitNr]):SetAlpha(0.9);
		else
			getglobal(HBUnitFrameName[unitNr]):SetAlpha(1);
		end
		getglobal(HBUnitFrameName[unitNr].."_HEALTHBAR"):SetSize(math.ceil(Healbot_BarSize * div),34);
		getglobal(HBUnitFrameName[unitNr].."_txt_hp"):SetText(Healbot_HPDivColor(div)..string.sub(curHP,1,6).."/"..string.sub(maxHP,1,6));
	end
end

function Healbot_ShowResBtn(unitNr)
	if UnitHealth(nUnitName[unitNr]) == 0 then
		getglobal(HBUnitFrameName[unitNr].."_btn6"):Show()
	elseif UnitHealth(nUnitName[unitNr]) > 0 then
		getglobal(HBUnitFrameName[unitNr].."_btn6"):Hide()
	end
end

function Healbot_ShowRes()
	if GetNumPartyMembers() < 2 then return end
	HBPCI1, HBPCI2 = indexClass("player");
	if (HBPCI1 == 8 and UnitLevel("player") >= 12) or (HBPCI1 == 1 and UnitLevel("player") >= 9) then
		for i = 1, GetNumPartyMembers()-1 do
			Healbot_ShowResBtn(i)
		end
		if UnitIsPlayer("target") then
			Healbot_ShowResBtn(6)
		end
	end
end

function Healbot_SkillColor(c1)
	if c1 == 1 or c1 == 5 or c1 == 6 or c1 == 7 or c1 == 8 then
		return hbskcol[1]["r"],hbskcol[1]["g"],hbskcol[1]["b"],hbskcol[1]["a"]
	elseif c1 == 2 then
		return hbskcol[3]["r"],hbskcol[3]["g"],hbskcol[3]["b"],hbskcol[3]["a"]
	elseif c1 == 3 then
		return hbskcol[4]["r"],hbskcol[4]["g"],hbskcol[4]["b"],hbskcol[4]["a"]
	elseif c1 == 4 then
		return hbskcol[2]["r"],hbskcol[2]["g"],hbskcol[2]["b"],hbskcol[2]["a"]
	elseif c1 == 9 then
		return hbskcol[2]["r"],hbskcol[2]["g"],hbskcol[2]["b"],hbskcol[2]["a"]
	elseif c1 == 10 then
		return hbskcol[3]["r"],hbskcol[3]["g"],hbskcol[3]["b"],hbskcol[3]["a"]
	end
end

function Healbot_ManaColor(mt)
	return hbskcol[mt]["r"],hbskcol[mt]["g"],hbskcol[mt]["b"],hbskcol[1]["a"]
end

function indexClass(arg1)
	local c1,c2 = UnitClass(arg1);

	for i = 1, 10 do
		if c1 == classeZ[i] or c1 == classeZZ[i] then
			c1 = i;
		end
	end
	for j = 1, 10 do
		if c2 == classeZ[j] or c2 == classeZZ[j] then
			c2 = j;
		elseif c2 == "" then
			c2 = 11;
		end
	end
	return c1,c2
end

function Healbot_SetMana(arg1)
--	local c1,c2 = indexClass(arg1)
	local m1 = UnitManaType(arg1)
	local m2 = UnitSkillType(arg1)
	local a, b, manaType
	if (m1 == 1 or m2 ~= 1 or HBPCI2 == 9) then
		a, b = UnitMana(arg1), UnitMaxMana(arg1)
		manaType = m1
	else
		a, b = UnitSkill(arg1), UnitMaxSkill(arg1)
		manaType = m2
	end
	if sUnitNumber[arg1]~=nil then
		local unitFrame = getglobal(HBUnitFrameName[sUnitNumber[arg1]].."_MANABAR")
		unitFrame:SetSize(math.ceil(Healbot_BarSize * (a / b)),4)
		unitFrame:SetColor(Healbot_ManaColor(manaType))
	end
end

local skcol = {
	[1] = "|cff77ccff";		--Priest	lt blue
	[2] = "|cff77cc44";		--Scout 	green
	[3] = "|cffbbbbbb";		--Rogue 	grey
	[4] = "|cffff6666";		--Warrior 	red
	[5] = "|cffdddd33";		--Knight 	yellow
	[6] = "|cff5588ff";		--Mage 		dk blue
	[7] = "|cff77cc44";		--Warden 	green
	[8] = "|cff77cc99";		--Druid 	darker green
	[9] = "|cff778899";		--Champion 	light slate gray
	[10] = "|cff800080";	--Warlock 	purple
	[11] = ""; 				--empty
}

function Healbot_ClassColor(arg1)
	local c1,c2 = indexClass(arg1);
	local cc1, cc2 = skcol[c1], skcol[c2];
	local l1 = string.sub(classeZ[c1], 1, 1);
	local l2;
	---fix here!!
	if c2 >= 1 and c2 <= 10 then
		l2 = string.sub(classeZ[c2], 1, 1);
	else
		l2 = "";
	end
	return (" "..cc1..l1..cc2..l2..cc1.." ")
end

HB_display = {
	[1] = true,
	[2] = true,
	[3] = true,
	[4] = true,
	[5] = true,
}

function HBUnitText(unit)
	return "|cff999999"..UnitLevel(unit)..Healbot_ClassColor(unit)..string.sub(UnitName(unit), 1, 12)
end

function HBUpdatePartyMember(pn, forced)
	local unit = "party"..pn
	local unitF = "HUParty"..pn
	local unitFrame = getglobal(unitF)
	local unitPet = "party"..pn.."pet"
	local unitPetF = "HUParty"..pn.."Pet"
	local unitPetFrame = getglobal(unitPetF)
	if (UnitExists(unit)) and HB_display[pn] then
		if not unitFrame:IsVisible() or forced then
			unitFrame:Show()
			getglobal(unitF.."_txt"):SetText(HBUnitText(unit));
			Healbot_SetHealth(unit)
		end
		if (UnitIsThere(unit)) then
			unitFrame:SetAlpha(1)
		else
			unitFrame:SetAlpha(0.3)
		end
		if UnitExists(unitPet) then
			if not unitPetFrame:IsVisible() or forced then
				unitPetFrame:Show()
				getglobal(unitPetF.."_txt"):SetText(string.sub(UnitName(unitPet), 1, 13).."..")
			end
			getglobal(unitPetF.."_HEALTHBAR"):SetSize(math.ceil(50 * (UnitHealth(unitPet)/UnitMaxHealth(unitPet))),25)
			getglobal(unitPetF.."_txt_hp"):SetText(Healbot_HPColor(unitPet)..string.sub(UnitHealth(unitPet),1,5))
		elseif unitPetFrame:IsVisible() and not HBDebugMode then
			unitPetFrame:Hide()
		end
	elseif unitFrame:IsVisible() and not HBDebugMode then
		unitFrame:Hide()
	end
end

function Healbot_UpdatePartyTxt(forced)
	if (UnitExists("player")) then
		if forced then
			local pc1, pc2 = indexClass("player");
			HBPCI1, HBPCI2 = pc1, pc2;
			if pc1 == 1 then
				HBPriestIsPrimary(pc1, pc2);
			elseif pc2 == 1 then
				HBPriestIsSecondary(pc1, pc2);
			elseif pc1 == 8 or pc2 == 8 then
				HBDruid(pc1, pc2);
			else
				HBNotAPriest(pc1, pc2);
			end
			HUSelf_txt:SetText(HBUnitText("player"))
			Healbot_SetHealth("player")
		end

		if UnitExists("pet") then
			if not HUSelfPet:IsVisible() or forced then
				HUSelfPet:Show();
				HUSelfPet_txt:SetText(string.sub(UnitName("pet"), 1, 13).."..");
				Healbot_SetHealth("pet")
			end
		elseif HUSelfPet:IsVisible() and not HBDebugMode then
			HUSelfPet:Hide();
		end

		for pn = 1, 5 do
			HBUpdatePartyMember(pn, forced)
		end

	else
		HUSelf_txt:SetText(" ");
	end
end

function Healbot_LoadSavVars()
	local UN = UnitName("player")
	local UC = UnitClass("player");
	if (not Healbot_VAR) then
		Healbot_VAR = {}
		Healbot_VAR["Version"] = Version
		Healbot_VAR["transparency"] = 1
		Healbot_VAR["HideFocus"] = true
		Healbot_VAR["HBPosIsNotLocked"] = HBIsNotLocked
	end
	if not Healbot_VAR["transparency"] then
		Healbot_VAR["transparency"] = 1;
	else
		Healbot_UpdateAlpha()
	end
	if (not Healbot_VAR[UN]) then
		Healbot_VAR[UN] = {
			scale	 = 1,			-- Is scale the only setting stored per character?
		}
	end
	if not Healbot_VAR[UN][UC] then
		Healbot_VAR[UN][UC] = {
			shown = true,
			passive = false,
			ShowTarget = true,
		}
	end

	if not Healbot_VAR[UN][UC]["PetHealSkill"] then
		Healbot_VAR[UN][UC]["PetHealSkill"] = 1
	end
	local healSkills = IndexSkills()
	local ind = Healbot_VAR[UnitName("player")][UnitClass("player")]["PetHealSkill"]
	SelectedPetCastSkill = healSkills[ind]

	if not Healbot_VAR["Skin"] or not hbskintable[Healbot_VAR["Skin"]] then
		Healbot_VAR["Skin"] = "Glow"
	end
	Healbot_SetSelectedSkin()

	Healbot_LoadSavedColors()

	HBActive = Healbot_VAR[UN][UC]["shown"]
	if HBActive then
		HUSelf:Show()
	else
		HUSelf:Hide()
		HBIntro:Hide()
		HUTgt:Hide()
	end

	VarsSet = true;

	HBConfig();  -- Update the config screen
	-- HBCheckTarget();  --- ????
end

function Healbot_OnUpdate(frame, elapsedTime)
	if not VarsSet then return end
	if UnitClassToken("player") == nil then return end -- Zoning

	HBLowHPTick(elapsedTime)
	HBPassiveTick(elapsedTime)

	if (MOTargeting) and (IsShiftKeyDown()) and (UnitExists("mouseover")) then
		TargetUnit("mouseover");
	end

	updateTime = updateTime + elapsedTime
	if updateTime >= updateIntervall and HBActive then
		if GetPlayerGoodEvil() < -10 then
			HBDisable()
		end
		Healbot_UpdatePartyTxt();
		HBCheckPartyBuff()
		HBCheckSelfBuff()
		Healbot_ShowRes()
		HBCheckTarget()
		if IsShiftKeyDown() then
			if not HUSelf_btnr:IsVisible() then
				HUSelf_btnr:Show()
				HUTgt_btnx:Show()
				HUParty1_btnx:Show()
				HUParty2_btnx:Show()
				HUParty3_btnx:Show()
				HUParty4_btnx:Show()
				HUParty5_btnx:Show()
			end
		elseif HUSelf_btnr:IsVisible() then
			HUSelf_btnr:Hide()
			HUTgt_btnx:Hide()
			HUParty1_btnx:Hide()
			HUParty2_btnx:Hide()
			HUParty3_btnx:Hide()
			HUParty4_btnx:Hide()
			HUParty5_btnx:Hide()
		end
		updateTime = 0
	end
end

function HBPositionOnScreen(x, y)
	local scale = HUSelf:GetScale() * GetUIScale()
	local maxX = GetScreenWidth()-(200*scale)
	local maxY = GetScreenHeight()-(36*scale)
	x, y = HBRound(x, 0), HBRound(y, 0)
	if x > maxX then x = maxX elseif x < 0 then x = 0 end
	if y > maxY then y = maxY elseif y < 0 then y = 0 end
	return x, y, scale
end

function HBSetFramePosition(frame, x, y)
	local scale
	x, y, scale = HBPositionOnScreen(x, y)
	frame:ClearAllAnchors()
	frame:SetAnchor("TOPLEFT", "TOPLEFT", "UIParent", x / scale, y / scale)
	return x, y
end

function HBLoadPosition()
	if (Healbot_VAR["bardistance"]==nil) then
		Healbot_VAR["bardistance"] = HBBarDistance;
	else
		HBBarDistance = Healbot_VAR["bardistance"];
	end

	if (Healbot_VAR[UnitName("player")]["x"]==nil or Healbot_VAR[UnitName("player")]["y"] == nil) then
		Healbot_VAR[UnitName("player")]["x"], Healbot_VAR[UnitName("player")]["y"] = HUSelf:GetPos();
	end
	if (Healbot_VAR[UnitName("player")]["tx"]==nil or Healbot_VAR[UnitName("player")]["ty"] == nil) then
		Healbot_VAR[UnitName("player")]["tx"], Healbot_VAR[UnitName("player")]["ty"] = HUTgt:GetPos();
	end
	local x, y  = tonumber(Healbot_VAR[UnitName("player")]["x"]), tonumber(Healbot_VAR[UnitName("player")]["y"]);
	local tx, ty  = tonumber(Healbot_VAR[UnitName("player")]["tx"]), tonumber(Healbot_VAR[UnitName("player")]["ty"]);
	local	scale = Healbot_VAR[UnitName("player")]["scale"];
	if type(scale) ~= "number" or scale < 0.4 or scale > 4 then
		scale = 1
		Healbot_VAR[UnitName("player")]["scale"] = scale
	end
	HUSelf:SetScale(scale)
	HBSetFramePosition(HUSelf, x, y)
	HUTgt:SetScale(scale)
	HBSetFramePosition(HUTgt, tx, ty)

	for i = 1, 5 do
		if Healbot_VAR[UnitName("player")]["p"..i.."x"] ~= nil and
			 Healbot_VAR[UnitName("player")]["p"..i.."y"] ~= nil then
			local x,y = Healbot_VAR[UnitName("player")]["p"..i.."x"], Healbot_VAR[UnitName("player")]["p"..i.."y"]
			HBSetFramePosition(getglobal("HUParty"..i), x, y)
		else
			getglobal("HUParty"..i):ClearAllAnchors();
			getglobal("HUParty"..i):SetAnchor("TOPLEFT", "TOPLEFT", "HUSelf", 0, i*HBBarDistance)
		end
	end

end

function HBCheckTarget()
	if HUTgtShow and HBActive then
		local tn = UnitName("target")
		if tn~=nil	and tn~=UnitName("player") and tn~=UnitName("party1") and tn~=UnitName("party2") and
			 tn~=UnitName("party3") and tn~=UnitName("party4") and tn~=UnitName("party5") and
			 UnitIsPlayer("target") then
			HUTgt_txt:SetText(HBUnitText("target"))
			local curHealth, maxHealth = UnitHealth("target"), UnitMaxHealth("target")
			HUTgt_txt_hp:SetText(Healbot_HPColor("target")..string.sub(curHealth,1,5).."/"..string.sub(maxHealth,1,5));
			HUTgt_HEALTHBAR:SetSize(math.ceil(Healbot_BarSize * (curHealth/maxHealth)),34);
			HUTgt:Show();
			HBCheckTargetBuff()
		elseif HUTgt:IsVisible() and not HBDebugMode then
			HUTgt:Hide();
		end
	elseif HUTgt:IsVisible() then
		HUTgt:Hide();
	end
end

--[[ Function from nBuff by Noktrin ]]
function Healbot_castSpell(target, spellName1)
	-- save current target if we have one and it's not the one we want
	local f = false;
	if UnitExists("target") and not UnitIsUnit("target", target) then
		FocusUnit(12, "target");
		f = true;
	end
	TargetUnit(target);
	-- cast the spell
	CastSpellByName(spellName1);
	-- restore target
	if f then
		TargetUnit("focus12");
		FocusUnit(12, "");
	end
	if (FocusHide == true) then
		FocusFrame:Hide();
	else
		FocusFrame:Show();
	end
end

---------------------
-- New button click handler
---------------------

function btnClick(arg1)
	HBFadeIn();
	if (string.find(arg1, "HUSelf")) then
		for h = 1,9 do
			if (string.find(arg1, "_btn"..h)) then
				Healbot_castSpell("player", skillZ[h]);
			end
		end
	elseif (string.find(arg1, "TOP")) then
		if (string.find(arg1, "_btn1")) then
			CastSpellByName(skillZ[10]);
		end
		if (string.find(arg1, "_btn2")) then
			CastSpellByName(skillZ[11]);
		end
		if (string.find(arg1, "_btn3")) then
			HBCfgMenuToggle();
		end
	elseif (string.find(arg1, "HUParty")) then
		for f = 1, GetNumPartyMembers()-1 do
			if (string.find(arg1, "HUParty"..f)) then
				for g = 1, 9 do
					if (string.find(arg1, "_btn"..g)) then
						Healbot_castSpell(nUnitName[f] ,skillZ[g]);
					end
				end
			end
		end
	elseif (string.find(arg1, "HUTgt")) then
		for h = 1,9 do
			if (string.find(arg1, "_btn"..h)) then
				Healbot_castSpell("target",skillZ[h]);
			end
		end
	end
end

function HBSetBuffBtn(unitNr, check, btn, icon, txt)
	local unitF = HBUnitFrameName[unitNr]
	if check then
		if btn then
			getglobal(unitF.."_btn"..btn):Hide()
		end
		if icon then
			getglobal(unitF.."_"..icon):Show()
			if txt~=nil then
				getglobal(unitF.."_"..icon.."_txt"):Show()
				getglobal(unitF.."_"..icon.."_txt"):SetText(txt)
			end
		end
	else
		if btn then
			getglobal(unitF.."_btn"..btn):Show()
		end
		if icon then
			getglobal(unitF.."_"..icon):Hide()
			if txt~=nil then
				getglobal(unitF.."_"..icon.."_txt"):Hide()
			end
		end
	end
end

-- unitNr  0=player, 1=party1, 2=party2...5=party5, 6=target
function HBCheckUnitBuff(unitNr)
	local pLevel = UnitLevel("player");

	if (HBPCI1 == 8 or HBPCI2 == 8) and pLevel >= 20 then  -- Check druid buffs
		local check = { [5]=false, [6]=false }
		local i = 1
		local buff = UnitBuff(nUnitName[unitNr], i)
		while buff ~= nil do
			for j = 5, 6 do
				if (buff == buffZ[j]) then
					check[j] = true
				end
			end
			i = i + 1
			buff = UnitBuff(nUnitName[unitNr], i)
		end
		HBSetBuffBtn(unitNr, check[5], "5", "SHIELD")
		if pLevel >= 26 and HBPCI1 == 8 then
			HBSetBuffBtn(unitNr, check[6], "1", "SALVE")
		end
	elseif HBPCI1 == 1 or HBPCI2 == 1 then  -- Check for priest buffs
		local nbuf = 4
		if pLevel < 2 or HBPCI2 == 1 then
			nbuf = 1
		end
		local check = { false, false, false, false }
		local cnt = { 0, 0, 0, 0 }
		local i = 1
		local buff = UnitBuff(nUnitName[unitNr], i)
		while buff ~= nil do
			for j = 1, nbuf do
				if (buff == buffZ[j]) then
					check[j] = true
					cnt[j] = cnt[j] + 1
				end
			end
			i = i + 1
			buff = UnitBuff(nUnitName[unitNr], i)
		end
		HBSetBuffBtn(unitNr, check[1], nil, "HOT", cnt[1])  -- Does not hide the HoT button when a HoT is active
		-- HBSetBuffBtn(unitNr, check[1], "4", "HOT", cnt[1]) -- Hides the HoT button when a HoT is active
		if pLevel >= 2 and HBPCI1 == 1 then
			HBSetBuffBtn(unitNr, check[2] or check[4], "5", "SHIELD")
		end
		if pLevel >= 28 and HBPCI1 == 1 then
			HBSetBuffBtn(unitNr, check[3], 1, "SALVE")
		end
	end
end

function HBCheckTargetBuff()
	HBCheckUnitBuff(6)
end

function HBCheckSelfBuff()
	HBCheckUnitBuff(0)
end

function HBCheckPartyBuff()
	if GetNumPartyMembers() <= 1 then return end
	for f = 1, GetNumPartyMembers()-1 do
		HBCheckUnitBuff(f)
	end
end

function UnitIsThere(unit_id)
    -- if not UnitExists(unit_id) then
        -- return false;
    -- end

--    if not UnitName(unit_id) then
--        return false;
--    end

   if string.sub(unit_id, 1, 5) == "party" then
--        local portrit = getglobal("UnitFrame_" .. unit_id .. "PortraitDefaultTexture");
--        if portrit:IsVisible() then
--            return false;
--        end

        local name, online = GetPartyMember(tonumber(string.sub(unit_id, 6, 6)));

        if not online then
            return false;
        end
    end

    return true;
end

